//========================================================================
// Simple FPGA Cell
//========================================================================

`ifndef SQUARE_WAVE_SV
`define SQUARE_WAVE_SV

module square_wave_generator
(
  input logic clk,
  input logic reset,

  input logic frequency,

  output logic wave
);

  localparam clk_frquency = 40000000;

  logic max_count;
  logic [31:0] count;

  assign max_count = clk_frquency / frequency;

  always @(posedge clk) begin
    if (reset) begin
      count <= 1'b0;
      wave <= 1'b0;
    end
    else begin
      count <= count + 1;
      if (count == max_count) begin
        count <= 1'b0;
        wave <= ~wave;
      end
    end
  end

endmodule

`endif /* SQUARE_WAVE_SV */
